TRUE 				equ 1
FALSE				equ 0

SCREENWIDTH			equ 80
SCREENHEIGHT		equ 25

CURSORCOUNT			equ 4

_DATA				segment word public 'DATA'

	extrn			_lpfnOldTickerHandler:dword
	extrn			_lpfnOldVideoHandler:dword
	extrn			_lpsVGA:dword
	extrn			_ac8x8Font:byte
	extrn			_awVirtDisplayed:word
	extrn			_awVirtNew:word
	extrn			_wMaxToCompare:word
	extrn			_wMaxToWrite:word

	VGASave			db 12 dup (?)
	VGASet			db 002h,00Fh
					db 00Fh,000h,000h,000h,000h,000h,00Ah,005h,000h,0FFh

	acColorReMap	db 00h,0Ch,0Ah,0Eh,09h,0Dh,0Bh,07h
					db 08h,04h,02h,06h,01h,05h,03h,0Fh

	wLastCompare	dw 0
	wNumCompared	dw 0
	wNumWritten		dw 0

	cCursorRow		db 0
	cCursorColumn	db 0
	cCursorStart	db 06h
	cCursorEnd		db 07h

	bCursorOn		db FALSE 
	bCursorWasOn	db FALSE ; Temporary... used to allow us to remember state.
	cCursorCount	db CURSORCOUNT

_DATA				ends

_TEXT				segment byte public 'CODE'

	assume			cs:_TEXT,ds:_DATA

	SaveVGA			proc near
					; DS:DI points to array destination on entry.
					; DI,Flags corrupted.

					cld

					push es
					push ax
					push bx
					push cx
					push dx

					push ds
					pop es

					; Sequencer map register first...

					mov dx,03C4h
					in al,dx ; Save current register in use
					stosb

					mov al,2
					out dx,al
					inc dx
					in al,dx
					dec dx
					stosb

					; Now do the graphics registers...

					mov dx,03CEh

					in al,dx ; Save current register in use
					stosb

					mov bl,0 ; Hold register no. in bl

	SaveVGA_1:		mov al,bl
					out dx,al
					inc dx
					in al,dx
					dec dx
					stosb
					inc bl
					cmp bl,9
					jb SaveVGA_1

					pop dx
					pop cx
					pop bx
					pop ax
					pop es

					ret

	SaveVGA			endp

	RestoreVGA		proc near
					; DS:SI point to array source on entry.
					; SI,Flags corrupted.

					cld

					push ax
					push bx
					push cx
					push dx

					; Sequencer map register first...

					mov dx,03C4h

					lodsb
					mov bh,al ; Save first value

					lodsb
					mov ah,al
					mov al,2
					out dx,ax

					mov al,bh
					out dx,al

					; Now do the graphics registers...

					mov dx,03CEh

					lodsb
					mov bh,al ; Save first value

					mov bl,0 ; Hold register no. in bl

	RestoreVGA_1:	lodsb
					mov ah,al
					mov al,bl
					out dx,ax
					inc bl
					cmp bl,9
					jb RestoreVGA_1

					mov al,bh
					out dx,al

					pop dx
					pop cx
					pop bx
					pop ax

					ret

	RestoreVGA		endp

	InvertCursor	proc near
					; DS=DataSeg

					push es
					push di
					push ax
					push bx
					push cx
					push dx

					mov al,cCursorRow
					cmp al,SCREENHEIGHT
					jae InvertCursor_4
					xor ah,ah
					shl ax,1
					shl ax,1
					shl ax,1

					mov bl,cCursorStart
					cmp bl,6
					jb InvertCursor_2
					mov bl,6

	InvertCursor_2:	mov cl,cCursorEnd
					cmp cl,7
					jb InvertCursor_3
					mov cl,7

	InvertCursor_3:	sub cl,bl ; cx has no. of lines to invert
					jb InvertCursor_4
					inc cl
					xor ch,ch

					xor bh,bh
					add ax,bx
					mov bx,80
					mul bx
					xor bh,bh
					mov bl,cCursorColumn
					cmp bl,SCREENWIDTH
					jae InvertCursor_4
					add ax,bx
					les di,_lpsVGA
					add di,ax

					mov dx,03CEh
					mov ax,1803h ; XOR the values...
					out dx,ax
					mov ax,0FF08h
					out dx,ax

	InvertCursor_1:	and byte ptr es:[di],0Fh
					add di,SCREENWIDTH
					loop InvertCursor_1

					mov ax,0003h ; REPLACE the values...
					out dx,ax

	InvertCursor_4:	pop dx
					pop cx
					pop bx
					pop ax
					pop di
					pop es

					ret

	InvertCursor	endp

	CursorOn		proc near

					; Assumes DS is dataseg

					cmp bCursorOn,FALSE
					jne CursorOn_1

					mov bCursorOn,TRUE
					call InvertCursor

	CursorOn_1:		ret

	CursorOn		endp

	CursorOff		proc near

					; Assumes DS is dataseg

					cmp bCursorOn,TRUE
					jne CursorOff_1

					mov bCursorOn,FALSE
					call InvertCursor

	CursorOff_1:	ret

	CursorOff		endp

	WriteChar		proc near
					; BX has the character to write
					; AX has the linear position to write
					; DS is at the data segment.
					; ES,DI,SI,CX,AX,DX,BX corrupted.

					call CursorOff

					les di,_lpsVGA
					mov dx,80
					div dl ; ah has x, al has y.
					mov dl,ah
					add di,dx

					mov dx,80*8
					xor ah,ah
					mul dx
					add di,ax

					lea si,_ac8x8Font
					mov al,8
					mul bl
					add si,ax

					; Remap the colors...
					mov bl,bh ; Get bl=foreground color, bh=background
					mov cl,bl
					and bx,0Fh
					mov ch,acColorReMap[bx]
					mov bl,cl
					mov cl,4
					shr bl,cl
					mov bh,acColorReMap[bx]
					mov bl,ch

					mov dx,03CEh
					mov cx,8 ; Number of lines/char
					mov al,8 ; Bit Mask register

	   WriteChar_1: mov ah,[si]
					out dx,ax
					and es:[di],bl

					not ah
					out dx,ax
					and es:[di],bh

					inc si
					add di,SCREENWIDTH
					loop WriteChar_1

					ret

	WriteChar		endp

	DoRefresh		proc near
					; DS is at data seg.
					; Check which characters need updating on the screen.
					; Destroys AX,SI,DI,ES,CX,DX,BX

					cld

					mov al,bCursorOn
					mov bCursorWasOn,al

					push ds
					pop es
					lea si,_awVirtNew
					lea di,_awVirtDisplayed
					mov ax,wLastCompare
					shl ax,1
					add si,ax
					add di,ax

					mov wNumCompared,0
					mov wNumWritten,0

	DoRefresh_1:	cmp wLastCompare,SCREENWIDTH*SCREENHEIGHT
					jb DoRefresh_2

					mov wLastCompare,0
					lea si,_awVirtNew
					lea di,_awVirtDisplayed

	DoRefresh_2:	inc wLastCompare
					cmpsw
					jne DoRefresh_4

	DoRefresh_3:	inc wNumCompared
					mov ax,_wMaxToCompare
					cmp wNumCompared,ax
					jb DoRefresh_1

					jmp DoRefresh_5

	DoRefresh_4:	; Write out a new character

					mov bx,[si-2]
					mov [di-2],bx
					mov ax,wLastCompare
					dec ax

					push si
					push di
					push es

					call WriteChar

					pop es
					pop di
					pop si

					inc wNumWritten
					mov ax,_wMaxToWrite
					cmp wNumWritten,ax
					jb DoRefresh_3

	DoRefresh_5:	dec cCursorCount
					jne DoRefresh_6

					xor bCursorWasOn,TRUE
					mov cCursorCount,CURSORCOUNT

	DoRefresh_6:    cmp bCursorWasOn,TRUE
					je DoRefresh_7

					call CursorOff
					jmp DoRefresh_8

	DoRefresh_7:	call CursorOn

	DoRefresh_8:	ret

	DoRefresh		endp

	public			_TickerHandler

	_TickerHandler	proc far

	assume			ds:nothing

					sti

					push ds
					push ax

					mov ax,_DATA
					mov ds,ax

	assume			ds:_DATA

					push bx
					push cx
					push dx
					push di
					push si
					push es

					; Save current VGA state

					lea di,VGASave
					call SaveVGA

					; Set VGA state

					lea si,VGASet
					call RestoreVGA

					;****************

					call DoRefresh

					;****************

					; Restore to old VGA state

					lea si,VGASave
					call RestoreVGA

					pop es
					pop si
					pop di
					pop dx
					pop cx
					pop bx

					pushf
					cli
					call [_lpfnOldTickerHandler]
					sti

					pop ax
					pop ds

	assume			ds:nothing

					iret

	_TickerHandler	endp

	;********************************************************************
	;
	; Video handler patches.
	;
	;********************************************************************

	public			_VideoHandler

	_VideoHandler	proc far

	assume			ds:nothing

					sti

					push ds
					push ax

					mov ax,_DATA
					mov ds,ax

	assume			ds:_DATA

					pop ax

					cmp ah,00h ; Ignore mode set
					jne VideoHandler_1
					jmp VideoHandlerExit

	VideoHandler_1:	cmp ax,1A00h ; Handle Get Display Combination code
					jne VideoHandler_2

					mov al,1Ah
					mov bx,0108h
					jmp VideoHandlerExit

	VideoHandler_2:	cmp ah,0Fh ; Handle Get Video Mode
					jne VideoHandler_3

					mov ax,5083h
					mov bh,0
					jmp VideoHandlerExit

	VideoHandler_3:	cmp ax,101Ah ; Handle Get Color Page State
					jne VideoHandler_4
					mov bx,0
					jmp VideoHandlerExit

	VideoHandler_4:	cmp ax,1202h ; Handle Set 400 Scan Lines
					jne VideoHandler_5
					cmp bl,30h
					jne VideoHandler_5
					mov al,12h
					jmp VideoHandlerExit

	VideoHandler_5:	cmp ax,1114h ; Ignore Load ROM 8x16 Font
					jne VideoHandler_6
					jmp VideoHandlerExit

	VideoHandler_6:	cmp ax,1003h ; Ignore Toggle Blink/Intensity Bit
					jne VideoHandler_7
					jmp VideoHandlerExit

	VideoHandler_7:	cmp ah,05h ; Ignore Set Display Page
					jne VideoHandler_8
					jmp VideoHandlerExit

	VideoHandler_8:	cmp ah,03h ; Handle Get Cursor Position
					jne VideoHandler_9
					mov ch,cCursorStart
					mov cl,cCursorEnd
					mov dh,cCursorRow
					mov dl,cCursorColumn
					jmp VideoHandlerExit

	VideoHandler_9:	cmp ax,1130h ; Get Font Information
					jne VideoHandler_10
					mov cx,0010h
					mov dl,18h ; Don't bother setting up font addr.
					jmp VideoHandlerExit

	VideoHandler_10:	cmp ah,02h ; Set Curosr Position
					jne VideoHandler_11
					push di
					push si
					cli
					lea di,VGASave
					call SaveVGA
					lea si,VGASet
					call RestoreVGA

					;****************

					call CursorOff
					mov cCursorRow,dh
					mov cCursorColumn,dl
					call CursorOn

					;****************

					lea si,VGASave
					call RestoreVGA
					sti
					pop si
					pop di
					jmp VideoHandlerExit

	VideoHandler_11:	cmp ah,01h ; Set Cursor Type
					jne VideoHandler_12
					push di
					push si
					cli
					lea di,VGASave
					call SaveVGA
					lea si,VGASet
					call RestoreVGA

					;****************

					call CursorOff
					mov cCursorStart,ch
					mov cCursorEnd,cl
					call CursorOn

					;****************

					lea si,VGASave
					call RestoreVGA
					sti
					pop si
					pop di
					jmp VideoHandlerExit

	VideoHandler_12:	pushf
					cli
					call [_lpfnOldVideoHandler]
					sti

	VideoHandlerExit:	pop ds

	assume			ds:nothing

					iret

	_VideoHandler	endp

_TEXT				ends

end
