#define _WINDOWS
#include <windows.h>

#define HEIGHT 25
#define WIDTH 80

extern WORD _0040H;
extern WORD _A000H;
extern WORD _B000H;
extern WORD _B800H;
extern DWORD FAR PASCAL GetSelectorBase(WORD wSelector);
extern WORD FAR PASCAL SetSelectorBase(WORD wSelector,DWORD dwBase);
extern DWORD FAR PASCAL GetSelectorLimit(WORD wSelector);
extern void FAR PASCAL SetSelectorLimit(WORD wSelector,DWORD dwLimit);
extern WORD FAR PASCAL AllocCSToDSAlias(WORD wSelector);
extern void FAR PASCAL DOS3Call(void);

LPSTR lpsVGA=NULL;
WORD awVirtDisplayed[WIDTH*HEIGHT];
WORD awVirtNew[WIDTH*HEIGHT];
WORD wMaxToCompare=1000;
WORD wMaxToWrite=200;
FARPROC lpfnOldTickerHandler;
FARPROC lpfnOldVideoHandler;

static char szAppName[]="SplitCVW";

extern void _interrupt far TickerHandler(void);
extern void _interrupt far VideoHandler(void);

static void SetVect(BYTE c,FARPROC lpfn)
{
	_asm
	{
		mov ah,025h
		mov al,c
		push ds
		lds dx,lpfn
		call DOS3Call
		pop ds
	}
}

static FARPROC GetVect(BYTE c)
{
	_asm
	{
		mov ah,035h
		mov al,c
		call DOS3Call
		mov ax,bx
		mov dx,es
	}
}

long FAR PASCAL WndProc(HWND hWnd,unsigned message,WORD wParam,LONG lParam)
{
	switch (message)
	{
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd,message,wParam,lParam);
	}
	return FALSE;
}

int PASCAL WinMain(HANDLE hInstance,HANDLE hPrevInstance,LPSTR lpCmdLine,
	int nCmdShow)
{
	WORD wsVGA=NULL;
	WORD wsDS;
	WORD wsCS;
	DWORD dwOldB800HBase;
	MSG msg;
	HWND hWnd;

	if (hPrevInstance)
	{
		return FALSE;
	}

	/* Register the window class... */
	{
		WNDCLASS wc;

		wc.style=NULL;
		wc.lpfnWndProc=WndProc;
		wc.cbClsExtra=0;
		wc.cbWndExtra=0;
		wc.hInstance=hInstance;
		wc.hIcon=NULL;
		wc.hCursor=LoadCursor(NULL,IDC_ARROW);
		wc.hbrBackground=GetStockObject(LTGRAY_BRUSH);
		wc.lpszMenuName=NULL;
		wc.lpszClassName=szAppName;

		if (!RegisterClass(&wc))
		{
			return FALSE;
		}
	}

	/* Create the window... */

	hWnd=CreateWindow(szAppName,szAppName,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,NULL,hInstance,NULL);

	if (!hWnd)
	{
		return FALSE;
	}

	ShowWindow(hWnd,SW_SHOWMINIMIZED);
	UpdateWindow(hWnd);

	/* Get our data selector. */
	_asm
	{
		push ds
		pop wsDS
	}

	/* Lock our data. */
	LockData(0);
	GlobalFix(wsDS);
	GlobalPageLock(wsDS);

	/* Get our code selector. */
	_asm
	{
		push cs
		pop wsCS
	}

	/* Lock our code. */
	LockSegment(wsCS);
	GlobalFix(wsCS);
	GlobalPageLock(wsCS);

	/* Get the VGA graphics screen. */
	{
		WORD wsCodeVGA;

		wsCodeVGA=AllocSelector(NULL);
		wsVGA=AllocCSToDSAlias(wsCodeVGA);
		FreeSelector(wsCodeVGA);
	}
	SetSelectorBase(wsVGA,0x000A0000L);
	SetSelectorLimit(wsVGA,16000L);
	LockSegment(wsVGA);
	GlobalFix(wsVGA);
	GlobalPageLock(wsVGA);
	lpsVGA=(LPSTR)MAKELONG(0,wsVGA);

	/* Map the monochrome monitor onto the new virtual screen. */
	dwOldB800HBase=GetSelectorBase((WORD)&_B800H);
	SetSelectorBase((WORD)&_B800H,GetSelectorBase(wsDS)+(WORD)awVirtNew);

	/* Initilaise both screens... */
	{
		WORD w;

		for (w=0;w<WIDTH*HEIGHT;w++)
		{
			if (w<64)
			{
				awVirtNew[w]=' '+(((w>>2) & 0x0F)<<12);
			}
			else
			{
				awVirtNew[w]=' '+0x7000;
			}
			awVirtDisplayed[w]=0xFFFF;
		}
	}

	/* Set up ticker interrupt... */
	lpfnOldTickerHandler=GetVect(0x08);
	SetVect(0x08,(FARPROC)TickerHandler);

	/* Set up video handler... */
	lpfnOldVideoHandler=GetVect(0x10);
	SetVect(0x10,(FARPROC)VideoHandler);

	/* Main message loop. */
	do
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{
			if (msg.message!=WM_QUIT)
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else
		{
			/* TickerHandler(); */
		}
	}
	while (msg.message!=WM_QUIT);

	/* Restore video interrupt... */
	SetVect(0x10,lpfnOldVideoHandler);

	/* Restore ticker interrupt... */
	SetVect(0x08,lpfnOldTickerHandler);

	/* Remap monochrome selector back... */
	SetSelectorBase((WORD)&_B800H,dwOldB800HBase);

	/* Free the VGA graphics screen. */
	GlobalPageUnlock(wsVGA);
	GlobalUnfix(wsVGA);
	UnlockSegment(wsVGA);
	FreeSelector(wsVGA);

	/* Unlock our code... */
	GlobalPageUnlock(wsCS);
	GlobalUnfix(wsCS);
	UnlockSegment(wsCS);

	/* Unlock our data... */
	GlobalPageUnlock(wsDS);
	GlobalUnfix(wsDS);
	UnlockData(0);

	return msg.wParam;
}
